/**
 * @file	AppConf.h
 * @brief	Application Configuration
 *
 * Put all defines that configure application and libraries into this file.
 *
 * This configuration is automatically injected into the application and all
 * included libraries during the build process.
 */
#ifndef APPCONF_H_
#define APPCONF_H_

/**
 * Debuglog Output Level (determines which logmessages get compiled)
 *
 * \li 0: None
 * \li 0: None
 * \li 1: Low
 * \li 2: Medium
 * \li 4: High
 * \li 5: Verbose (default)
 */
#define DEBUGLOG_LEVEL		(DEBUG_RADIO | VERBOSE)

#endif /*APPCONF_H_*/
