/* 
Modified linker script org: mspgcc/msp430/lib/ldscripts/msp430x1612.x 
*/


OUTPUT_FORMAT("elf32-msp430","elf32-msp430","elf32-msp430")
OUTPUT_ARCH(msp:16)
MEMORY
{
	data   (rwx)		: ORIGIN = 0x1100, 	LENGTH = 0x1400
	text   (rx)			: ORIGIN = 0x2500,  LENGTH = 0xdae0
    INT00               : ORIGIN = 0xFFE0, LENGTH = 0x0002
    INT01               : ORIGIN = 0xFFE2, LENGTH = 0x0002
    INT02               : ORIGIN = 0xFFE4, LENGTH = 0x0002
    INT03               : ORIGIN = 0xFFE6, LENGTH = 0x0002
    INT04               : ORIGIN = 0xFFE8, LENGTH = 0x0002
    INT05               : ORIGIN = 0xFFEA, LENGTH = 0x0002
    INT06               : ORIGIN = 0xFFEC, LENGTH = 0x0002
    INT07               : ORIGIN = 0xFFEE, LENGTH = 0x0002
    INT08               : ORIGIN = 0xFFF0, LENGTH = 0x0002
    INT09               : ORIGIN = 0xFFF2, LENGTH = 0x0002
    INT10               : ORIGIN = 0xFFF4, LENGTH = 0x0002
    INT11               : ORIGIN = 0xFFF6, LENGTH = 0x0002
    INT12               : ORIGIN = 0xFFF8, LENGTH = 0x0002
    INT13               : ORIGIN = 0xFFFA, LENGTH = 0x0002
    INT14               : ORIGIN = 0xFFFC, LENGTH = 0x0002
    RESET               : ORIGIN = 0xFFFE, LENGTH = 0x0002
	bootloader(rx)		: ORIGIN = 0x0c00,	LENGTH = 1K
	infomem(rx)			: ORIGIN = 0x1000,	LENGTH = 256
	infomemnobits(rx)	: ORIGIN = 0x1000,  LENGTH = 256
}

NOCROSSREFS(.bldtext .text)

INCLUDE ldbldapp.x

SECTIONS
{

  /*****************************************************************************
   ***                                                                       ***
   *** Text section (goes all into flash memory)                             ***
   ***                                                                       ***
   *****************************************************************************/

	/* BOOTLOADER section */
	.romstart : {
		PROVIDE(__bld_start = . );
		PROVIDE(__bld_header = . );
	} > text
	.bldtext : {
		. += BLD_SIZE;
	} > text
	PROVIDE(__bld_end = . );

	/* Read-only sections, merged into text segment.  */
	.hash          : { *(.hash)             }
	.dynsym        : { *(.dynsym)           }
	.dynstr        : { *(.dynstr)           }
	.gnu.version   : { *(.gnu.version)      }
	.gnu.version_d   : { *(.gnu.version_d)  }
	.gnu.version_r   : { *(.gnu.version_r)  }
	.rel.init      : { *(.rel.init) }
	.rela.init     : { *(.rela.init) }
	.rel.text      :
	{
	  *(.rel.text)
	  *(.rel.text.*)
	  *(.rel.gnu.linkonce.t*)
	}
	.rela.text     :
	{
	  *(.rela.text)
	  *(.rela.text.*)
	  *(.rela.gnu.linkonce.t*)
	}
	.rel.fini      : { *(.rel.fini) }
	.rela.fini     : { *(.rela.fini) }
	.rel.rodata    :
	{
	  *(.rel.rodata)
	  *(.rel.rodata.*)
	  *(.rel.gnu.linkonce.r*)
	}
	.rela.rodata   :
	{
	  *(.rela.rodata)
	  *(.rela.rodata.*)
	  *(.rela.gnu.linkonce.r*)
	}
	.rel.data      :
	{
	  *(.rel.data)
	  *(.rel.data.*)
	  *(.rel.gnu.linkonce.d*)
	}
	.rela.data     :
	{
	  *(.rela.data)
	  *(.rela.data.*)
	  *(.rela.gnu.linkonce.d*)
	}
	.rel.ctors     : { *(.rel.ctors)        }
	.rela.ctors    : { *(.rela.ctors)       }
	.rel.dtors     : { *(.rel.dtors)        }
	.rela.dtors    : { *(.rela.dtors)       }
	.rel.got       : { *(.rel.got)          }
	.rela.got      : { *(.rela.got)         }
	.rel.bss       : { *(.rel.bss)          }
	.rela.bss      : { *(.rela.bss)         }
	.rel.plt       : { *(.rel.plt)          }
	.rela.plt      : { *(.rela.plt)         }

	/* APPLICATION section */
	.text : {
		/*--- EOS and APP headers ---*/
		PROVIDE (__app_start = .);
		PROVIDE (__app_header = .);
		*(.app_header)
		. = ALIGN(2); 
		PROVIDE (__eos_header = .);
		*(.eos_header)
		. = ALIGN(2);

		/*--- TERMINAL command table ---*/    
		PROVIDE (__term_start = .) ;
		*(.commands)
		PROVIDE (__term_end = .);
		. = ALIGN(2);

		. = ALIGN(2);
		*(.init)
		*(.init0)  /* Start here after reset.  */
		*(.init1)
		*(.init2)  /* Copy data loop  */
		*(.init3)
		*(.init4)  /* Clear bss  */
		*(.init5)
		*(.init6)  /* C++ constructors.  */
		*(.init7)
		*(.init8)
		*(.init9)  /* Call main().  */
		__ctors_start = . ;
		*(.ctors)
		__ctors_end = . ;
		__dtors_start = . ;
		*(.dtors)
		__dtors_end = . ;
		. = ALIGN(2);

		/*--- the CODE ---*/
	    *(.text)
		. = ALIGN(2);
		*(.text.*)
		. = ALIGN(2);

		*(.fini9)  /*   */
		*(.fini8)
		*(.fini7)
		*(.fini6)  /* C++ destructors.  */
		*(.fini5)
		*(.fini4)
		*(.fini3)
		*(.fini2)
		*(.fini1)
		*(.fini0)  /* Infinite loop after program termination.  */
		*(.fini)

	    _etext = .;
		__app_end = .;
	} > text

	.fwdata 0x1100 : {
	    *(.vectors)
	    . = ALIGN(2);
	    *(.wdstate);
	    . = ALIGN(2);
	} > data

	/*.data : AT (ADDR (.text) + SIZEOF (.text))*/
	.data : 
	{
		PROVIDE (__data_start = .) ;
		. = ALIGN(2);
		*(.data)
		*(SORT_BY_ALIGNMENT(.data.*))
		. = ALIGN(2);
		*(.gnu.linkonce.d*)
		. = ALIGN(2);
		_edata = . ;
	}  > data AT > text
	PROVIDE (__data_load_start = LOADADDR(.data) );
	PROVIDE (__data_size = SIZEOF(.data) );

  
	/*.bss SIZEOF(.data) + ADDR(.data) :*/
	.bss :
	{
		PROVIDE (__bss_start = .) ;
		*(.bss)
		*(SORT_BY_ALIGNMENT(.bss.*))
		*(COMMON)
		PROVIDE (__bss_end = .) ;
		_end = . ;
	}  > data
	PROVIDE (__bss_size = SIZEOF(.bss) );

	.noinit SIZEOF(.bss) + ADDR(.bss) :
	{
		 PROVIDE (__noinit_start = .) ;
		*(.noinit)
		*(COMMON)
		 PROVIDE (__noinit_end = .) ;
		 _end = . ;
	}  > data
  
	/* IRQ */
    .int00   : {} > INT00
    .int01   : {} > INT01
    .int02   : {} > INT02
    .int03   : {} > INT03
    .int04   : {} > INT04
    .int05   : {} > INT05
    .int06   : {} > INT06
    .int07   : {} > INT07
    .int08   : {} > INT08
    .int09   : {} > INT09
    .int10   : {} > INT10
    .int11   : {} > INT11
    .int12   : {} > INT12
    .int13   : {} > INT13
    .int14   : {} > INT14
    .reset   : {} > RESET

  /*****************************************************************************
   ***                                                                       ***
   *** Other                                                                 ***
   ***                                                                       ***
   *****************************************************************************/  
  
  /* Stabs for profiling information*/
  .profiler 0 : { *(.profiler) }
  /* Stabs debugging sections.  */
  .stab 0 : { *(.stab) }
  .stabstr 0 : { *(.stabstr) }
  .stab.excl 0 : { *(.stab.excl) }
  .stab.exclstr 0 : { *(.stab.exclstr) }
  .stab.index 0 : { *(.stab.index) }
  .stab.indexstr 0 : { *(.stab.indexstr) }
  .comment 0 : { *(.comment) }
  /* DWARF debug sections.
     Symbols in the DWARF debugging sections are relative to the beginning
     of the section so we begin them at 0.  */
  /* DWARF 1 */
  .debug          0 : { *(.debug) }
  .line           0 : { *(.line) }
  /* GNU DWARF 1 extensions */
  .debug_srcinfo  0 : { *(.debug_srcinfo) }
  .debug_sfnames  0 : { *(.debug_sfnames) }
  /* DWARF 1.1 and DWARF 2 */
  .debug_aranges  0 : { *(.debug_aranges) }
  .debug_pubnames 0 : { *(.debug_pubnames) }
  /* DWARF 2 */
  .debug_info     0 : { *(.debug_info) *(.gnu.linkonce.wi.*) }
  .debug_abbrev   0 : { *(.debug_abbrev) }
  .debug_line     0 : { *(.debug_line) }
  .debug_frame    0 : { *(.debug_frame) }
  .debug_str      0 : { *(.debug_str) }
  .debug_loc      0 : { *(.debug_loc) }
  .debug_macinfo  0 : { *(.debug_macinfo) }
  
  PROVIDE (__infomem = 0x1000) ;
  PROVIDE (__stack = 0x2500) ;
  PROVIDE (__data_start_rom = _etext) ;
  PROVIDE (__data_end_rom   = _etext + SIZEOF (.data)) ;
  PROVIDE (__noinit_start_rom = _etext + SIZEOF (.data)) ;
  PROVIDE (__noinit_end_rom = _etext + SIZEOF (.data) + SIZEOF (.noinit)) ;
  PROVIDE (__subdevice_has_heap = 0) ;
}
